package com.restlet.client.commons;

public abstract class AppConstants {

    public enum ExternalLink {
        AddChromeReview(getChromeExtensionReviewsUrl(), "writing a review"),
        ClientExtension(getChromeExtensionUrl(), getClientModuleName()),
        ClientDocumentation(getClientDocumentationUrl(), "Documentation"),
        ClientMavenPluginDocumentation(getMavenPluginDocumentationUrl(), "Maven documentation"),
        ClientPage(getClientPageUrl(), getClientModuleName()),
        ClientApp(getClientAppUrl(), getClientModuleName()),
        CloudPage(getCloudPageUrl(), getCloudModuleName()),
        CloudApp(getCloudAppUrl(), getCloudModuleName()),
        StudioPage(getStudioPageUrl(), getStudioModuleName()),
        StudioApp(getStudioAppUrl(), getStudioModuleName());

        public final String link;
        public final String label;

        ExternalLink(final String link, final String label) {
            this.link = link;
            this.label = label;
        }
    }

    public static String getProviderDomain() {
        return "client.restlet.com";
    }

    public static String getTwitterId() {
        return "restlet";
    }

    public static String getSupportEmail() {
        return "support@restlet.com";
    }

    public static String getTwitterUrl() {
        return "https://twitter.com/restlet";
    }

    public static String getClientModuleName() {
        return "Restlet Client";
    }

    public static String getClientDocumentationUrl() {
        return "https://restlet.com/documentation/client/guide?utm_source=DHC";
    }

    public static String getMavenPluginDocumentationUrl() {
        return "https://restlet.com/documentation/client/guide/run-tests/automate-tests/test-reports-maven?utm_source=DHC";
    }

    public static String getClientPageUrl() { return "https://restlet.com/modules/client?utm_source=DHC"; }

    public static String getClientAppUrl() {
        return "https://client.restlet.com";
    }

    public static String getStudioModuleName() {
        return "Restlet Studio";
    }

    public static String getStudioPageUrl() { return "https://restlet.com/modules/studio?utm_source=DHC"; }

    public static String getStudioAppUrl() {
        return "https://studio.restlet.com";
    }

    public static String getCloudModuleName() {
        return "Restlet Cloud";
    }

    public static String getCloudPageUrl() { return "https://restlet.com/modules/cloud?utm_source=DHC"; }

    public static String getCloudAppUrl() {
        return "https://cloud.restlet.com";
    }

    public static String getChromeExtensionUrl() {
        return "https://chrome.google.com/webstore/detail/restlet-client/aejoelaoggembcahagimdiliamlcdmfm";
    }

    public static String getChromeExtensionReviewsUrl() { return getChromeExtensionUrl() + "/reviews"; }

    public static String getSystinetName() {
        return "HP Systinet";
    }

    public static String getSwaggerName() {
        return "Swagger";
    }

    public static String getHarName() {
        return "HAR";
    }

}
