package com.restlet.client.dao;

import com.restlet.client.async.Promise;
import com.restlet.client.model.ImportPolicy;
import com.restlet.client.model.context.ContextConfigTo;
import com.restlet.client.model.context.ContextTo;
import com.restlet.client.utils.Nullable;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface ContextsDao {

    Promise<List<ContextTo>> list();

    Promise<ContextTo> findByName(String contextName);

    Promise<ContextTo> read(String contextId);

    Promise<ContextTo> readSelected();

    Promise<ContextTo> persist(ContextTo context);

    Promise<Void> delete(ContextTo context);

    @Deprecated
    Promise<ContextConfigTo> readConfig();

    @Deprecated
    Promise<Void> patchSelected(String contextName);

    Promise<List<ContextTo>> importContexts(final ImportPolicy importPolicy, final Map<String, ContextTo> contexts, @Nullable final Set<String> importOnly);

    Promise<Integer> count();
}
