package com.restlet.client.dao;

import com.restlet.client.async.Promise;
import com.restlet.client.commons.Component;
import com.restlet.client.net.http.response.HttpResponseTo;
import com.restlet.client.net.response.ResponseBodyTo;
import com.restlet.client.utils.NotNull;

public interface ResponsesDao extends Component {

    Promise<String> put(@NotNull HttpResponseTo result, String id);

    Promise<HttpResponseTo> read(@NotNull HttpResponseTo id);

    Promise<HttpResponseTo> read(@NotNull String id);

    Promise<Void> delete(@NotNull HttpResponseTo result);

    Promise<Void> delete(@NotNull String id);

    Promise<HttpResponseTo> findLast(@NotNull String repositoryId);    //TODO use request MD5 hash

    Promise<Void> clear();

    Promise<String> putBody(ResponseBodyTo body);

    Promise<ResponseBodyTo> readBody(ResponseBodyTo body);
}
