package com.restlet.client.html.form.impl;

import com.restlet.client.html.form.FormItemTo;
import com.restlet.client.html.form.FormTo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class FormToImpl implements FormTo, Serializable {

    private static final long serialVersionUID = 3403235503306407145L;

    List<FormItemTo> items;
    boolean overrideContentType;
    String encoding;

    @Override
    public List<FormItemTo> getItems() {
        return items;
    }

    @Override
    public void setItems(List<FormItemTo> items) {
        this.items = items;
    }

    @Override
    public boolean getOverrideContentType() {
        return overrideContentType;
    }

    @Override
    public void setOverrideContentType(boolean overrideContentType) {
        this.overrideContentType = overrideContentType;
    }

    @Override
    public String getEncoding() {
        return encoding;
    }

    @Override
    public void setEncoding(String encoding) {
        this.encoding = encoding;
    }

    @Override
    public FormTo clone() {
        FormToImpl clone = new FormToImpl();
        clone.setEncoding(encoding);
        clone.setOverrideContentType(overrideContentType);
        if (items != null) {
            ArrayList<FormItemTo> clonedItems = new ArrayList<>();
            for (FormItemTo item : items) {
                clonedItems.add(item.clone());
            }
            clone.setItems(clonedItems);
        }

        return clone;
    }
}
