package com.restlet.client.net.http.request;

import com.restlet.client.net.http.HttpExampleTo;
import com.restlet.client.net.request.RequestBodyTo;
import com.restlet.client.net.request.RequestHeaderTo;
import com.restlet.client.net.request.RequestHeadersType;
import com.restlet.client.net.request.RequestTo;

import java.util.List;
import java.util.Map;


public interface HttpRequestTo extends RequestTo {

    HttpMethodDefinition getMethod();

    void setMethod(final HttpMethodDefinition method);

    List<RequestHeaderTo> getHeaders();

    void setHeaders(final List<RequestHeaderTo> headers);

    RequestHeadersType getHeadersType();

    void setHeadersType(final RequestHeadersType type);

    boolean getUriEditor();

    void setUriEditor(boolean visible);

    RequestBodyTo getBody();

    void setBody(RequestBodyTo body);

    boolean containsNoErrors();

    void wrap(HttpRequestTo request);

    List<HttpExampleTo> getExamples();

    void setExamples(List<HttpExampleTo> examples);

    Map<String, String> getMetaInfo();

    void setMetaInfo(Map<String, String> meta);

    boolean isBodyEvaluationDisabled();

    void setBodyEvaluationDisabled(boolean value);

}
