package com.restlet.client.script.method;

import com.restlet.client.async.Promise;
import com.restlet.client.async.Promises;
import com.restlet.client.platform.Base64;
import com.restlet.client.platform.json.JsonEngine;
import com.restlet.client.script.runtime.ScriptMethod;
import com.restlet.client.script.runtime.ScriptValue;
import com.restlet.client.script.value.ScriptStringValue;

import java.util.List;

public class Base64Method implements ScriptMethod {

    private final Base64 base64;

    final JsonEngine jsonEngine;

    public Base64Method(Base64 base64, JsonEngine jsonEngine) {
        this.base64 = base64;
        this.jsonEngine = jsonEngine;
    }

    @Override
    public String getName() {
        return "base64";
    }

    @Override
    public Promise<ScriptValue> execute(ScriptValue value, List<ScriptValue> args) {

        if (value == null) {
            return Promises.of();
        }

        return Promises.of((ScriptValue) new ScriptStringValue(base64.encode(value.toString()), jsonEngine));
    }

}
