package com.restlet.client.script.method;

import com.restlet.client.async.Promise;
import com.restlet.client.async.Promises;
import com.restlet.client.platform.RandomValueGenerator;
import com.restlet.client.script.runtime.ScriptMethod;
import com.restlet.client.script.runtime.ScriptValue;
import com.restlet.client.script.value.ScriptNumberValue;

import java.util.List;

public class RandomNumberMethod implements ScriptMethod {

    static final int MAX = 1000000000;

    final RandomValueGenerator generator;

    public RandomNumberMethod(RandomValueGenerator generator) {
        this.generator = generator;
    }

    @Override
    public String getName() {
        return "random";
    }

    @Override
    public Promise<ScriptValue> execute(ScriptValue value, List<ScriptValue> args) {

        if (args != null && !args.isEmpty()) {
            try {
                Integer max = Integer.valueOf(args.iterator().next().toString());
                if (max != null && max < MAX) {
                    return Promises.when(new ScriptNumberValue(Long.valueOf(generator.nextInt(max))));
                }

            } catch (NumberFormatException e) {

            }

        }

        return Promises.when(new ScriptNumberValue(Long.valueOf(generator.nextInt(MAX))));
    }

}
