package com.restlet.client.script.runtime.impl;

import com.restlet.client.async.Promise;
import com.restlet.client.dao.ContextsDao;
import com.restlet.client.dao.RepositoryDao;
import com.restlet.client.model.EntityTo;
import com.restlet.client.script.RepositoryReader;
import com.restlet.client.script.runtime.ScriptValue;

public class RepositoryRecordReference implements ScriptValue {

    final RepositoryReader repositoryReader;
    final EntityTo entity;
    private ContextsDao contextsDao;
    final RepositoryDao repositoryDao;

    public RepositoryRecordReference(RepositoryReader exprSvc, EntityTo entity, ContextsDao contextsDao, RepositoryDao repositoryDao) {
        this.repositoryReader = exprSvc;
        this.entity = entity;
        this.contextsDao = contextsDao;
        this.repositoryDao = repositoryDao;
    }

    @Override
    public String toString() {
        return "{\"name\":\"" + entity.getName() + "\",\"type\":\"" + entity.getType() + "\"}";
    }

    @Override
    public Promise<ScriptValue> select(String path) {
        return repositoryReader.readFromRepo(path, entity, repositoryDao, contextsDao);
    }
}
