package com.restlet.client.tests.asserts;

public interface AssertionTo {

    Boolean isEnabled();

    void setEnabled(Boolean enabled);

    Subject getSubject();

    void setSubject(Subject subject);

    String getPath();

    void setPath(String path);

    Comparison getComparison();

    void setComparison(Comparison comparison);

    String getValue();

    void setValue(String value);

    enum Subject {
        Response("Response", "the response", false),
        ResponseStatus("Status", "the status", false),
        ResponseHeader("Header", "the header", true),
        ResponseJsonBody("JSON Body", "the JSON body identified by", false),
        ResponseXmlBody("XML Body", "the XML body identified by ", false),
        ResponseBody("Body", "the body", false);

        public final String dropdownText;
        public final String textualDescription;
        public final boolean supportExpressionBuilder;

        Subject(String dropdownText, String textualDescription, boolean supportExpressionBuilder) {
            this.dropdownText = dropdownText;
            this.textualDescription = textualDescription;
            this.supportExpressionBuilder = supportExpressionBuilder;
        }

        public String asString() {
            return dropdownText;
        }
    }

    enum Comparison {
        IsBlank(false, "Is blank", "should be blank"),
        IsNotBlank(false, "Is not blank", "should not be blank"),
        Equals(true, "Equals", "should be equal to"),
        DoesNotEqual(true, "Does not equal", "should not be equal to"),
        Contains(true, "Contains", "should contain"),
        DoesNotContain(true, "Does not contain", "should not contain"),
        Less(true, "Less", "should be lesser than"),
        LessOrEqual(true, "Less or equal", "should be lesser or equal than"),
        Greater(true, "Greater", "should be greater than"),
        GreateOrEqual(true, "Greater or equal", "should be greater or equal than"),
        Exists(false, "Exists", "should exist"),
        DoesNotExist(false, "Does not exist", "should not exist");

        private boolean hasParameter;
        public final String dropdownName;
        public final String textualDescription;

        Comparison(boolean hasParameter, String dropdownName, String textualDescription) {
            this.hasParameter = hasParameter;
            this.dropdownName = dropdownName;
            this.textualDescription = textualDescription;
        }

        public boolean hasParameter() {
            return hasParameter;
        }

        public String asString() {
            return dropdownName;
        }
    }

}
