package com.restlet.client.utils;

import com.restlet.client.model.context.ContextVariableTo;

import java.util.List;

import static com.restlet.client.utils.StringUtils.isBlank;

public class ContextToHelper {

    public static String expandVariables(List<ContextVariableTo> variables, String text) {
        if (isBlank(text)) {
            return null;
        }
        return getVariableValue(variables, text);
    }


    private static String getVariableValue(List<ContextVariableTo> variables, String varName) {
        if (variables == null || isBlank(varName)) {
            return null;
        }

        for (ContextVariableTo variable : variables) {
            if ((variable.getEnabled() == null || variable.getEnabled()) && varName.equals(variable.getName())) {
                return variable.getValue();
            }
        }
        return null;
    }


}
