package com.restlet.client.utils;

import com.restlet.client.function.Function;
import com.restlet.client.model.EntityTo;
import com.restlet.client.model.EntityTreeNode;

public abstract class EntityCloner {

    public static EntityCloner ENTITY_CLONER;

    public abstract <T extends EntityTo> T clone(T entity);

    public EntityTreeNode cloneEntityTreeNode(final EntityTreeNode nodeToClone) {
        final EntityTreeNode clonedTreeNode = new EntityTreeNode(clone(nodeToClone.entity), nodeToClone.updateType);
        clonedTreeNode.children.addAll(
                Sequence.of(nodeToClone.children)
                        .map(new Function<EntityTreeNode, EntityTreeNode>() {
                            @Override
                            public EntityTreeNode apply(final EntityTreeNode nodeToClone1) {
                                return EntityCloner.this.cloneEntityTreeNode(nodeToClone1);
                            }
                        })
                        .toList()
        );
        return clonedTreeNode;
    }


}
